food/urls.py
from . import views
from django.urls import path

app_name = 'food'

urlpatterns = [
    path('', views.ItemsViews.as_view(), name='items'),
    path('<int:pk>/', views.ItemsDetailsViews.as_view(), name='details'),
    path('add/', views.CreateItems.as_view(), name='create_items'),
    path('update/<int:item_id>/', views.update_items, name='update_items'),
    path('delete/<int:pk>/',
         views.DeleteItems.as_view(), name='delete_items'),
]

mysite/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('food/', include('food.urls')),
    path('user/', include('users.urls')),
]
urlpatterns += [
    # ... the rest of your URLconf goes here ...
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

users/urls.py
from . import views
from django.urls import path
from django.contrib.auth import views as auth_views
app_name = 'users'

urlpatterns = [
    path('register/', views.register, name=('register-user')),
    path('login/', auth_views.LoginView.as_view(
        template_name='users/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(
        template_name='users/logout.html'), name='logout'),
    path('profile/', views.profile, name='user-profile'),
]

food/models.py
from django.db import models
from django.contrib.auth.models import User
from django.urls import reverse


# Create your models here.
class Items(models.Model):
    DEF_IMG = 'https://static.wixstatic.com/media/bf242e_6133b4ae6a104cc2b50d70179f35efea~mv2.jpg/v1/fill/w_500,h_376,al_c,lg_1,q_80,enc_auto/food-placeholder.jpg'
    user = models.ForeignKey(User, on_delete=models.CASCADE,
                             null=True, blank=True)
    items_name = models.CharField(max_length=256)
    items_desc = models.CharField(max_length=256)
    items_price = models.FloatField()
    items_image = models.CharField(max_length=600,
                                   default=DEF_IMG)

    def __str__(self) -> str:
        return self.items_name

    def get_absolute_url(self):
        return reverse('food:details', kwargs={"pk": self.pk})

users/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.


class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    image = models.ImageField(default='user.jpg',
                              upload_to='profile_icon.png')
    location = models.CharField(max_length=256)

    def __str__(self):
        return self.user.username

food/forms.py
from django import forms
from .models import Items


class ItemsForm(forms.ModelForm):
    class Meta:
        model = Items
        fields = ['items_name', 'items_desc', 'items_price',
                  'items_image',]

users/forms.py
from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm


class UserForms(UserCreationForm):
    email = forms.EmailField()

    class Meta:
        model = User
        fields = ['username', 'email',
                  'password1', 'password2',]

food/views.py
from django.shortcuts import redirect, render
from .models import Items
from .forms import ItemsForm
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView
# from django.template import loader

# Create your views here.


# def hello(request):
#     return HttpResponse("Hellow word")


def items(request):
    food = Items.objects.all()
    # template = loader.get_template('food/index.html')
    context = {
        'item': food,
    }
    return render(request, 'food/index.html', context)


class ItemsViews(ListView):
    model = Items
    template_name = 'food/index.html'
    context_object_name = 'item'


def detail(request, item_id):
    items = Items.objects.get(pk=item_id)
    context = {
        'item_name': items.items_name,
        'item_price': items.items_price,
        'item_desc': items.items_desc,
        'item_img': items.items_image,
        'item_id': items.id,
    }
    return render(request, 'food/detail.html', context)


class ItemsDetailsViews(DetailView):
    model = Items
    template_name = 'food/detail.html'


def create_items(request):
    form = ItemsForm(request.POST or None)

    if form.is_valid():
        form.save()
        return redirect('food:items')
    return render(request, 'food/from-create.html', {'form': form})


class CreateItems(CreateView):
    model = Items
    template_name = 'food/from-create.html'
    fields = ['items_name', 'items_desc', 'items_price',
              'items_image']

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)


def update_items(request, item_id):
    items = Items.objects.get(pk=item_id)
    form = ItemsForm(request.POST or None, instance=items)

    if form.is_valid():
        form.save()
        return redirect('food:items')
    return render(request, 'food/from-create.html', {'form': form})


def delete_items(request, item_id):
    items = Items.objects.get(pk=item_id)
    print(f"**********{request.method}")
    if request.method == 'POST':
        print("**********")

        items.delete()
        return redirect('food:items')
    return render(request, 'food/delete.html', {'item_id': item_id})


class DeleteItems(DetailView):
    model = Items
    template_name = 'food/delete.html'

users/views.py
from django.shortcuts import redirect, render
from .forms import UserForms
from django.contrib import messages
from django.contrib.auth.decorators import login_required
# Create your views here.


def register(request):
    if request.method == 'POST':
        form = UserForms(request.POST)
        if form.is_valid():
            form.save()
            username = form.cleaned_data.get('username')
            messages.success(request, f"New User {username} have been created")
            return redirect('users:login')
    form = UserForms()
    return render(request, 'users/register.html', {"form": form})


@login_required
def profile(request):
    return render(request, 'users/profile.html')

food/templates/food/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
  <title>Document</title>
  <link rel="stylesheet" href="{% static '/food/style.css' %}">
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js"
    integrity="sha384-C6RzsynM9kWDrMNeT87bh95OGNyZPhcTNXj1NW7RuBCsyN/o0jlpcV8Qyq46cDfL"
    crossorigin="anonymous"></script>
</head>

<body>

<nav class="navbar navbar-expand-lg bg-primary">
  <div class="container-fluid">
    <a class="navbar-brand text-white" href="{% url 'food:items' %}">My App</a>
    <div id="navbarNav">
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link text-white" href="{% url 'food:create_items' %}">Add Items</a>
        </li>
        <li class="nav-item">
          <a class="nav-link text-white" href="{% url 'users:register-user' %}">Sign Up</a>
        </li>
        {% if user.is_authenticated %}
          <li class="nav-item">
            <a class="nav-link text-white" href="{% url 'users:logout' %}">Logout</a>
          </li>
          <li class="nav-item">
            <a class="nav-link text-white" href="{% url 'users:user-profile' %}">Profile</a>
          </li>
        {% else %}
          <li class="nav-item">
            <a class="nav-link text-white" href="{% url 'users:login' %}">Log In</a>
          </li>
        {% endif %}
      </ul>
    </div>
  </div>
</nav>

{% if messages %}
  {% for mess in messages %}
    <div class="alert alert-{{ mess.tags }}">
      {{ mess }}
    </div>
  {% endfor %}
{% endif %}

{% block body %}
{% endblock %}

</body>

</html>

food/templates/food/delete.html
<form method="POST">
    {% csrf_token %}
    <h2> Are you sure want to delete {{object.items_name}}</h2>
    <button type="submit">Delete</button>
</form>   

food/templates/food/detail.html
{%  extends 'food/base.html' %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    {% block body%}
    <div class="container">
        <div class="row">
            <div class="col-md-6">
                <img height="200px" src="{{object.items_image}}">
            </div>
            
            <div class="col-md-6">
                <h3>{{object.items_name}}</h3>
                <h4>{{object.items_desc}}</h3>
                <h5>Rs {{object.items_price}}</h3>
                <h6>{{object.user.username}}</h6>
                <button type="submit">
                    <a href="{% url 'food:delete_items' object.pk%}" class="btn btn-danger">Delete</a>
                </button>

            </div>
        </div>
    </div>
    {% endblock %}

</body>
</html>

food/templates/food/from-create.html
{% extends 'food/base.html' %}
{% block body %}
<div class="container">
    <div class="row">
        <div class="col-md-3 offset-md-4">
            <div class="card">
                <div class="card-header text-white bg-primary">
                    <div class="card-title">Add Items</div>
                </div>
                <div class="card-body">
                    <form method="POST">
                        {% csrf_token %}
                        {% for field in form%}
                            <div class="form-group">
                                {{field.name}}
                                <br>
                                {{field}}
                            </div>
                        {% endfor %}
                        <p></p>
                        <p></p>
                        <button class="btn btn-primary" type="submit">Register</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

food/templates/food/index.html
{% extends 'food/base.html' %}
<!-- {% load static %} -->
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body >
    {% block body%}
    {% for i in item %}
    <div class="row">
        <div class="col-md-4 offset-md-2">
            <img class="card" height="200px" src="{{i.items_image}}">
        </div>

        <div class="col-md-3">
            <h3>Item Name: {{i.items_name}}</h3>
            <h3>Item Price: Rs {{i.items_price}} </h3>
        </div>

        <div class="col-md-2">
            <a href="{% url 'food:details' i.pk%}" class="btn btn-success">Details</a>
        </div>
    </div>
    <!-- <ol>
        <a href="{% url 'food:details' i.pk%}">
        <li>{{i.items_name}}</li></a>
    </ol> -->
    {% endfor %}
    {% endblock %}
</body>
</html>

users/templates/users/login.html
{% extends 'food/base.html' %}
{% block body %}
<div class="container">
    <div class="row">
        <div class="col-md-3 offset-md-4">
            <div class="card">
                <div class="card-header text-white bg-primary">
                    <div class="card-title">Log In</div>
                </div>
                <div class="card-body">
                    <form method="POST">
                        {% csrf_token %}
                        {% for field in form%}
                            <div class="form-group">
                                {{field.name}}
                                {{field}}
                            </div>
                        {% endfor %}
                        <p></p>
                        <p></p>
                        <button class="btn btn-primary" type="submit">Log In</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

users/templates/users/logout.html
<h1>You have been is logout</h1>

users/templates/users/profile.html
{% load static %}
<h1>{{user.username}}</h1>
<img src="{{user.profile.image.url}}" height="200px">

users/templates/users/register.html
{% extends 'food/base.html' %}
{% block body %}
<div class="container">
    <div class="row">
        <div class="col-md-3 offset-md-4">
            <div class="card">
                <div class="card-header text-white bg-primary">
                    <div class="card-title">User Register Form</div>
                </div>
                <div class="card-body">
                    <form method="POST">
                        {% csrf_token %}
                        {% for field in form%}
                            <div class="form-group">
                                {{field.name}}
                                <br>
                                {{field}}
                            </div>
                        {% endfor %}
                        <p></p>
                        <p></p>
                        <button class="btn btn-primary" type="submit">Sign Up</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}